
myFun = function(arg) {
  prod(arg)
}


proj.calc = function(ind.col,Design) {
  sub.matrix=as.matrix(Design[, ind.col] )
  prodV = apply(sub.matrix, 1, myFun)
  tmp=sum(prodV)^2
#  cat(ind.col, round(tmp/(noRun*noRun),3), "\n")
  return(tmp)
}

proj.calc.plus = function(ind.col, Design, b) {
  sub.matrix=as.matrix(cbind(Design[, ind.col], b) )
  prodV = apply(sub.matrix, 1, myFun)
  tmp=sum(prodV)^2
  return(tmp)
}


F.mod = function(bc, a, a.min, b.min, c.min,  c.max, noCol) {
# number of models with a.min, b.min, c.min effects included and 
# whose number of parameters are less than run size
   if (a + sum(bc) < noRun) {
	ret = c(a, bc,  choose(noCol-a.min, a-a.min) * choose(a-b.min, bc[1]-b.min) * choose(c.max-c.min, bc[2]-c.min))
#	print(ret)
  } else {
	ret = numeric(4)
  }
  ret
}



delta.mod = function(a.min, b.min, c.min, noCol ) {
#for second-order maximal model
#apply function F.mod to find delta for each combination of a,b,c 

  a.bound.min=min(noRun-1,noCol)
  tmp=0
  if (a.min<=noCol) {
  
   for(a in a.min:a.bound.min) {
      b.max=a
     c.max=choose(a,2)
      bc.max = noRun - a
      a1 = matrix( rep(b.min:b.max, c.max - c.min + 1), 
		c.max - c.min + 1, b.max - b.min + 1, byrow=T)
      a2 = matrix( rep(c.min:c.max, b.max - b.min + 1), 
		c.max - c.min + 1, b.max - b.min + 1)
      A = array(c(a1,a2), c(c.max - c.min + 1, b.max - b.min + 1, 2) )
      R= apply(A, c(1,2), F.mod, a, a.min, b.min, c.min, c.max, noCol)
#     print(R)
  
      tmp= tmp + sum(R[4,,])
     }
  } else {tmp=0}
  tmp
#  print(tmp)
}


num.mod2 = function(a.min, noCol) {
#number of model for first order maximal model 
   tmp=0
   a.bound.min=min((noRun-1), noCol)

   if (a.min<=a.bound.min)  {
       for (a in a.min:a.bound.min) {
        tmp = tmp + choose(noCol-a.min, a-a.min)
        }   
   }
#   print(tmp)
}


F.mod2.int = function(c.val, a, a.min, c.min, c.max, noCol) { 
   if (c.val+a < noRun ) {
     ret = choose(noCol-a.min, a-a.min) * choose(c.max-c.min, c.val-c.min)
      } else {
       ret=0    
     }  
}


 
delta2.int = function(ind, noCol) {
#for two-level second-order maximal model
#apply function F.mod to find delta for each combination of a,c 
  a.bound.min=min(noRun-1,noCol)
  tmp=0
  if (ind[1] <=noCol) {
      for(a in ind[1]:a.bound.min) {
        c.max=choose(a,2)
        c.ind=ind[2]:c.max
        tmp=tmp+sum(unlist(lapply(c.ind,  F.mod2.int, a, ind[1], ind[2], c.max, noCol)))
     }
   }
# print(tmp)
}
 

Q.lev2 = function(index,Design) {
  x=Design[,index]
  noCol=ncol(x)
  b.word=numeric(noCol)

  for( TC in 1:noCol)  {
    out=combinations(noCol,TC)
    b.word[TC]=sum(apply(out, 1, proj.calc, x))/(noRun*noRun)
  }
  return(b.word)
}


cal.Q.lev2 = function(x) {
   noCol=ncol(x)
    b.word=numeric(noCol)
    bmat=as.list(c())
  for( TC in 1:noCol)  {
    out=combinations(noCol,TC)
    bb=apply(out, 1, proj.calc, x)/(noRun*noRun)
    b.word[TC]=sum(bb)
    bmat=append(bmat, list(bb))
    }
   
  return(list(b.word=b.word, bmat=bmat))
}





cal.Q.bword=function(b.word, noCol){
  Q.1st=( b.word[1] * num.mod2(2, noCol)+
	  b.word[2] * 2 * num.mod2(3, noCol))/num.mod2(1, noCol)

  if (noCol==3) { 
      Q.2nd=( b.word[1] * ( delta2.int(c(1,0), noCol) + 
		2 * (noCol-1) * delta2.int(c(2,1), noCol) )  + 
	b.word[2] * ( 2 * delta2.int(c(2,0), noCol) + 
		delta2.int(c(2,1), noCol) + 
		2 * (noCol-2)*delta2.int(c(3,2), noCol)) + 
	b.word[3] * 6 * delta2.int(c(3,1), noCol) )/delta2.int(c(0,0), noCol)
   } else {
   Q.2nd=(b.word[1] * (delta2.int(c(1,0), noCol) + 
		2*(noCol-1) * delta2.int(c(2,1), noCol)  )+ 
	b.word[2] * ( 2 * delta2.int(c(2,0), noCol) + 
		delta2.int(c(2,1), noCol) + 
		2 * (noCol-2)*delta2.int(c(3,2), noCol) ) +
	b.word[3] * 6 * delta2.int(c(3,1), noCol) + 
	b.word[4] * 6 * delta2.int(c(4,2), noCol) )/delta2.int(c(0,0), noCol)
	}

   ret=c(Q.1st, Q.2nd)
}


combinations = function (n, r, v = 1:n, set = TRUE, repeats.allowed = FALSE) 
# `combinations' enumerates the possible combinations of a specified
#  size from the elements of a vector.
#  Original versions by Bill Venables Bill.Venables@cmis.csiro.au. 
#  Extended to handle `repeats.allowed' by Gregory R. Warnes
#  Gregory_R_Warnes\@groton.pfizer.com.

{
    if (mode(n) != "numeric" || length(n) != 1 || n < 1 || (n%%1) != 
        0) 
        stop("bad value of n")
    if (mode(r) != "numeric" || length(r) != 1 || r < 1 || (r%%1) != 
        0) 
        stop("bad value of r")
    if (!is.atomic(v) || length(v) < n) 
        stop("v is either non-atomic or too short")
    if ((r > n) & repeats.allowed == FALSE) 
        stop("r > n and repeats.allowed=FALSE")
    if (set) {
        v <- unique(sort(v))
        if (length(v) < n) 
            stop("too few different elements")
    }
    v0 <- vector(mode(v), 0)
    if (repeats.allowed) 
        sub <- function(n, r, v) {
            if (r == 0) 
                v0
            else if (r == 1) 
                matrix(v, n, 1)
            else if (n == 1) 
                matrix(v, 1, r)
            else rbind(cbind(v[1], Recall(n, r - 1, v)), Recall(n - 
                1, r, v[-1]))
        }
    else sub <- function(n, r, v) {
        if (r == 0) 
            v0
        else if (r == 1) 
            matrix(v, n, 1)
        else if (r == n) 
            matrix(v, 1, n)
        else rbind(cbind(v[1], Recall(n - 1, r - 1, v[-1])), 
            Recall(n - 1, r, v[-1]))
    }
    sub(n, r, v[1:n])
}

