myFun = function(arg){
  prod(arg)
}


dim2=function(mat) {
  dim(mat)[2]
}


matrix.calc.fin = function(data) {
  prodV = apply(data, 1, myFun)
  (sum(prodV))^2/(noRun*noRun)
}


matrix.calc.real = function(nMatrix, combList, vec) {
  matrix.selected = c()
  for(i in 1:nMatrix) {
    combSlice = combList[[i]]
    matrix.selected = cbind(matrix.selected, 
                            myArray[, combSlice[vec[i],], i])
  }
  myRes = matrix.calc.fin(matrix.selected)
  myRes
}


matrix.calc.rec = function(nMatrix, depth, combList, vec, colUnion) {
  ret = c()
  if(depth==nMatrix+1) {
    ret = matrix.calc.real(nMatrix,combList,vec)
  } else {
    combSlice = combList[[depth]]
    if(dim(combSlice)[1]==0) {
      ret = c(ret, matrix.calc.rec(nMatrix, depth+1, combList, c(vec,0), colUnion))
    } else {
      for(i in 1:dim(combSlice)[1]) {
if( length(colUnion)==0 || 
            length(intersect(colUnion, combSlice[i,]))==0)
    ret = c(ret, matrix.calc.rec(nMatrix, depth+1, combList, c(vec, i), 
union(colUnion, combSlice[i,])))
      }
    }
  }
  ret
}




matrix.choose.vector = function(nMatrix, maxCount, cv) {
  for(i in 1:nMatrix) {
    if(i==1) {
      if(cv[i]==0) combList = list(matrix(0,0,0))
      else combList = list(combinations(maxCount, cv[i]))
    } else {
      if(cv[i]==0) combList = append(combList, list(matrix(0,0,0)))
      else combList = append(combList, list(combinations(maxCount, cv[i])))
    }
  }
  ret = matrix.calc.rec(nMatrix, 1, combList, c(), c())
  ind = unlist(lapply(combList, dim2))
  c(ind, sum(ret))
}



matrix.choose.count = function(nMatrix, maxCount, totalCount) {
  ceiling = (maxCount + 1) ^ nMatrix
  cv = rep(0, nMatrix)
  ret = c()
  for(counter in 1:(ceiling-1)) {
    val = counter
    for(i in nMatrix:1) {
      cv[i] = val %% (maxCount + 1)
      val = val %/% (maxCount + 1)
    }

    if(sum(cv)==totalCount) {
      ret = rbind(ret, matrix.choose.vector(nMatrix, maxCount, cv))
    }
  }
  ret
}





#copy from R package gtools
combinations=function (n, r, v = 1:n, set = TRUE, repeats.allowed = FALSE)
{
    if (mode(n) != "numeric" || length(n) != 1 || n < 1 || (n%%1) !=
        0)
        stop("bad value of n")
    if (mode(r) != "numeric" || length(r) != 1 || r < 1 || (r%%1) !=
        0)
        stop("bad value of r")
    if (!is.atomic(v) || length(v) < n)
        stop("v is either non-atomic or too short")
    if ((r > n) & repeats.allowed == FALSE)
        stop("r > n and repeats.allowed=FALSE")
    if (set) {
        v <- unique(sort(v))
        if (length(v) < n)
            stop("too few different elements")
    }
    v0 <- vector(mode(v), 0)
    if (repeats.allowed)
        sub <- function(n, r, v) {
            if (r == 0)
                v0
            else if (r == 1)
                matrix(v, n, 1)
            else if (n == 1)
                matrix(v, 1, r)
            else rbind(cbind(v[1], Recall(n, r - 1, v)), Recall(n -
                1, r, v[-1]))
        }
    else sub <- function(n, r, v) {
        if (r == 0)
            v0
        else if (r == 1)
            matrix(v, n, 1)
        else if (r == n)
            matrix(v, 1, n)
        else rbind(cbind(v[1], Recall(n - 1, r - 1, v[-1])),
            Recall(n - 1, r, v[-1]))
    }
    sub(n, r, v[1:n])
}

delta.mod = function(a.min, b.min, c.min, noCol ) {
#for second-order maximal model
#apply function F.mod to find delta for each combination of a,b,c 

  a.bound.min=min(noRun-1,noCol)
  tmp=0
  if (a.min<=noCol) {
  
   for(a in a.min:a.bound.min) {
      b.max=a
     c.max=choose(a,2)
      bc.max = noRun - a
      a1 = matrix( rep(b.min:b.max, c.max - c.min + 1), 
		c.max - c.min + 1, b.max - b.min + 1, byrow=T)
      a2 = matrix( rep(c.min:c.max, b.max - b.min + 1), 
		c.max - c.min + 1, b.max - b.min + 1)
      A = array(c(a1,a2), c(c.max - c.min + 1, b.max - b.min + 1, 2) )
      R= apply(A, c(1,2), F.mod, a, a.min, b.min, c.min, c.max, noCol)
#     print(R)
  
      tmp= tmp + sum(R[4,,])
     }
  } else {tmp=0}
  tmp
#  print(tmp)
}

F.mod = function(bc, a, a.min, b.min, c.min,  c.max, noCol) {
# number of models with a.min, b.min, c.min effects included and 
# whose number of parameters are less than run size
   if (a + sum(bc) < noRun) {
	ret = c(a, bc,  choose(noCol-a.min, a-a.min) * choose(a-b.min, bc[1]-b.min) * choose(c.max-c.min, bc[2]-c.min))
#	print(ret)
  } else {
	ret = numeric(4)
  }
  ret
}



delta.3.qual=function(a.min ,noCol) {
   a=1:noCol
   a.bound=length(a[(2*a+choose(a,2)*4)<noRun])
   tmp=0
   if (a.min<=a.bound) {
    for (i in a.min:a.bound) {
       tmp=tmp+choose(noCol-a.min,i-a.min)
    }
   }
  return(tmp)
}

total.effect = function(arg, len.arg){
   sum(arg*seq(len.arg)) }


word.sum = function(arg, ind) {
  sum(worList[ind==arg,noLev]) }

b.word =function(arg){
   true.index=c()
   for (i in 1:dim(worList)[1]) {
      if (all(worList[i,seq(length(arg))]==arg)=="TRUE")
          true.index=i
    }
     return(worList[true.index,noLev])  
} 


