#Plackett and Burman Designs "pb12.Rdat", "pb16.Rdat", "pb20.Rdat", "pb24.Rdat"
library("gtools")
#source("combinations.r")
source("Q2.r")

cat("run-size for plackett and burman designs. 12,16, 20 or 24?\n")
noRun=as.integer(readline())
cat("number of factors of interest, less than 11,15, 19 or 23?\n")
noF=as.integer(readline());

assign("noRun", noRun, envir=.GlobalEnv)
assign("noF", noF, envir=.GlobalEnv)

xi.ind=matrix(c(
0,1,2,2,3,3,4,
0,0,0,1,1,2,2), 2, 7, byrow=T)

delta.ij=apply(xi.ind, 2, delta2.int, noF)

for (i in 1:7){
	msg=paste("i", xi.ind[1,i], " j ")
      msg=paste(msg, xi.ind[2,i], sep="", collapse="")
	msg=paste(msg,  "delta = ", sep="  ", collapse=" ")
      msg=paste(msg, delta.ij[i],sep=" ", collapse="")
	cat(msg, "\n") 
   }
print(delta.ij/delta.ij[1])

Q.sum=function(b.word, delta.ij){
    tmp = ( b.word[1] * (delta.ij[2]+2*(noF-1) * delta.ij[4])+ 
	b.word[2] * ( 2 * delta.ij[3] + delta.ij[4]+ 2 * (noF-2)*delta.ij[6]) +
	b.word[3] * 6 * delta.ij[5] + 
	b.word[4] * 6 * delta.ij[7] )/delta.ij[1]	}

filename=paste("pb",noRun,".Rdat", sep="")
D_pb=matrix(scan(filename), nrow=noRun, byrow=T)

Design=replace(D_pb, D_pb==0, -1)

out=combinations(ncol(Design), noF)

A=apply(out, 1, Q.lev2, Design)
ind=!duplicated(A,MARGIN=2)    
ind.B=A[,ind]
ind.col=out[ind,]


if (length(ind.col)==noF) {
   ind.Q=Q.sum(ind.B,delta.ij)
   cat("Plackett-Burman Design in", noRun, "runs\n")
   for (i in 1:noRun) cat(format(Design[i,], width=4), sep="  ","\n")
   cat("There are  one non-isomorphic designs for designs with ", noF, " factors\n")
   cat("Plan for the design is : \n")
   for (ii in 1:noRun) cat(format(Design[ii,ind.col], width=4), sep="  ","\n")
   cat("Generalised word counts for this design are:\n")
   for (j in 1:noF){
	msg=paste("B", j, sep=" ", collapse="")
	msg=paste(msg, round(ind.B[j],4), sep=" : ", collapse="  ")
	cat(msg, "\n") 
   }
   msg = paste("Q second-order : ", round(ind.Q,4), sep=" ", collapse="")
   cat(msg, "\n")
   cat(" =====================", "\n")
   } else  {
   ind.Q=apply(ind.B, 2, Q.sum, delta.ij)
   cat("Plackett-Burman Design in", noRun, "runs\n")
   for (i in 1:noRun) cat(format(Design[i,], width=4), sep="  ","\n")
   msg=paste("There are ", dim(ind.col)[1], "non-isomorphic designs for designs with")
   msg=paste(msg, noF, " factors\n")
   cat(msg)
   for (i in 1:(dim(ind.col)[1])){
     cat("Plan for design", i, sep=" ", "\n")
     for (ii in 1:noRun) cat(format(Design[ii,ind.col[i,]], width=4), sep="  ","\n")
     cat("Generalised word counts for this design are:\n")
     for (j in 1:noF){
	 msg=paste("B", j, sep=" ", collapse="")
	 msg=paste(msg, round(ind.B[j,i],4), sep=" : ", collapse="  ")
	 cat(msg, "\n") 
     }
     msg = paste("Q second-order : ", round(ind.Q[i],4), sep=" ", collapse="")
     cat(msg, "\n")
     cat(" =====================", "\n")
  }
 }


