
#probability of a model with a particular set of a.val main effects and c.val being the fitting model
prb.calc=function(c.val, a.val, c.max, noF){
  if (c.val<=c.max) {
  prb.calc=p1^a.val*(1-p1)^(noF-a.val)*p2^c.val*(1-p2)^(c.max-c.val) }
 else {
   prb.calc=0}
}


#probability of  a model with a.val main effects and  each of 0 to c.max  interactions being the fitting model
#calling prb function of real calculation
prb=function(ac, noF){
   a.val=ac[1]
  c.max=ac[2]
  unlist(lapply(c(0:c.max), prb.calc, a.val, c.max, noF))
}
  

mod.num.calc=function(c.val, a.val, c.max, a.min, c.min, noF){
  mod.num.calc=choose(noF-a.min, a.val-a.min)*choose(c.max-c.min, c.val-c.min)
}

mod.num=function(ac, a.min, c.min, noF){
   a.val=ac[1]
   c.max=ac[2]
   unlist(lapply(c(0:c.max), mod.num.calc, a.val, c.max, a.min, c.min, noF))
}




delta.ij=function(vec, noF, noRun){
   a.min=vec[1]
   c.min=vec[2]
   a.ind=c(0:noF)
   c.ind=choose(a.ind,2)
   mod=apply(rbind(a.ind, c.ind), 2, mod.num, a.min, c.min, noF)
   for (i in 1:noF) {
    for (j in 0:c.ind[i+1]) {
       if ((i+j)>=noRun)    mod[[i+1]][j+1]=0
    }}
   delta.ij=sum(unlist(mod))
#   print(delta.ij)
}



prob.lev2=function(p1, p2, noF, noRun){
#a list of probability for model with i-1 main effects and 0 to c.max interaction being the fitting model (without adjustment)

xi.size=7
xi=numeric(xi.size)
xi.ind=matrix(c(
0,1,2,2,3,3,4,
0,0,0,1,1,2,2), 2, 7, byrow=T)
pij=c()
a.ind=c(0:noF)
c.ind=choose(a.ind,2)
prob=apply(rbind(a.ind,c.ind), 2, prb, noF)
mod=apply(rbind(a.ind, c.ind), 2, mod.num, 0, 0, noF)
delta=apply(xi.ind, 2, delta.ij, noF, noRun)

#mod is different from delta2.int in Q2.r since here non-eligible models still count
#mod[[i]][c.ind] the number of model with (i-1) main effects and (c.ind-1) interaction

A=matrix(0,0,0)
for (i in a.ind) {
   prb.m=mod[[i+1]]*prob[[i+1]]
    A=append(A, list(prb.m))
}
  
tmp.prob=0
tmp.num=0
for (i in 1:noF) {
  for (j in 0:c.ind[i+1]) {
     if ((i+j)>=noRun) {
         tmp.prob=tmp.prob+A[[i+1]][j+1]
#        print(c(i,j))
     }
    if ((i+j)==(noRun-1))  {
#     print(c(i,j))
      tmp.num=tmp.num+mod[[i+1]][j+1]}
    }
}

prob.adj=tmp.prob/tmp.num

for (i in 1:noF) {
  for (j in 0:c.ind[i+1]) {
     if ((i+j)>=noRun) {
#         print(c(i,j))
          prob[[i+1]][j+1]=0
     }
    if ((i+j)==(noRun-1))  {
             prob[[i+1]][j+1]= prob[[i+1]][j+1]+prob.adj
	}
    }
}
#adjust gamma to model of a size smaller.

A=matrix(0,0,0)
for (i in a.ind) {
   prb.m=mod[[i+1]]*prob[[i+1]]
    A=append(A, list(prb.m))
}
  
for (i.ind in 1:xi.size){
  a.min=xi.ind[1,i.ind]
  c.min=xi.ind[2,i.ind]
  mod.ad=apply(rbind(a.ind, c.ind), 2, mod.num, a.min, c.min, noF)
#  print(mod.ad)
  A.ad=matrix(0,0,0)
  for (i in a.ind) {
      prb.m=mod.ad[[i+1]]*prob[[i+1]]
      A.ad=append(A.ad, list(prb.m))
   }  
# print(c(a.min, c.min, sum(unlist(A.ad),na.rm=TRUE)))
  pij=rbind(pij, sum(unlist(A.ad),na.rm=TRUE))
  }
  pij=pij
}




cal.QB=function(p1,p2,d){
  noCol=ncol(d)
  noRun=nrow(d)
  b.word=numeric(noCol)
  for( TC in 1:noCol)  {
    out=combinations(noCol,TC)
    b.word[TC]=sum(apply(out, 1, proj.calc, d))/(noRun*noRun)
  }

  pij=prob.lev2(p1, p2, noCol, noRun)

  if (noCol==3) {
     Q.B=( b.word[1]*( pij[2] + 2*(noF-1)*pij[4] )+ 
	b.word[2] * ( 2*pij[3] + pij[4]+ 2*(noF-2)*pij[6] ) +
	b.word[3] * 6 * pij[5] ) / pij[1]
   } else {
   Q.B =( b.word[1]*( pij[2] + 2*(noF-1)*pij[4] )+ 
	b.word[2] * ( 2*pij[3] + pij[4]+ 2*(noF-2)*pij[6] ) +
	b.word[3] * 6 * pij[5] + b.word[4] * 6 * pij[7] ) / pij[1]
   } 

 return(list(Q.B=Q.B, b.word=b.word, pij=pij))
}


